/*!
 * @author electricessence / https://github.com/electricessence/
 * Licensing: MIT https://github.com/electricessence/TypeScript.NET/blob/master/LICENSE.md
 * Based on: https://en.wikipedia.org/wiki/Uniform_Resource_Identifier
 */
define(["require","exports","../Types","./QueryParams","./Scheme","../Text/Utility","../Exceptions/ArgumentException","../Exceptions/ArgumentOutOfRangeException"],function(t,e,r,n,i,u,o,s){"use strict";function a(t,e){var r,n=0;for(e||(e={});r=v[n++];){var i=t[r];i&&(e[r]=i)}return e}function f(t){var e=t;if(r.Type.isString(e)){if(!e)return null;if(e=u.trim(e).toLowerCase().replace(/[^a-z0-9+.-]+$/g,q),!e)return null;if(i.isValid(e))return e}else if(null===e||void 0===e)return e;throw new s.ArgumentOutOfRangeException("scheme",t,"Invalid scheme.")}function p(t){if(0===t)return t;if(!t)return null;var e;if(r.Type.isNumber(t,!0)){if(e=t,e>=0&&isFinite(e))return e}else if(r.Type.isString(t)&&(e=parseInt(t))&&!isNaN(e))return p(e);throw new o.ArgumentException("port","invalid value")}function c(t){if(!t.host){if(t.userInfo)throw new o.ArgumentException("host","Cannot include user info when there is no host.");if(r.Type.isNumber(t.port,!1))throw new o.ArgumentException("host","Cannot include a port when there is no host.")}var e=t.host||q;return e&&(t.userInfo&&(e=t.userInfo+E+e),isNaN(t.port)||(e+=":"+t.port),e=w+e),e}function h(t){return t&&(0!==t.indexOf(O)?O:q)+t}function l(t){return t&&(0!==t.indexOf(A)?A:q)+t}function g(t){var e=t.path,r=t.query;return q+(e||q)+(h(r)||q)}function y(t){var e=f(t.scheme),r=c(t),n=g(t),i=l(t.fragment),u=q+(e&&e+":"||q)+(r||q),s=q+(n||q)+(i||q);if(u&&s&&e&&!r)throw new o.ArgumentException("authority","Cannot format schemed Uri with missing authority.");return u&&n&&0!==n.indexOf(x)&&(s=x+s),u+s}function m(t,e){if(!t)return new o.ArgumentException("url","Nothing to parse.");var r,n={};if(r=t.indexOf(A),-1!=r&&(n.fragment=t.substring(r+1)||d,t=t.substring(0,r)),r=t.indexOf(O),-1!=r&&(n.query=t.substring(r+1)||d,t=t.substring(0,r)),r=t.indexOf(w),-1!=r){var i=u.trim(t.substring(0,r)),s=/:$/;if(!s.test(i))return new o.ArgumentException("url","Scheme was improperly formatted");i=u.trim(i.replace(s,q));try{n.scheme=f(i)||d}catch(p){return p}t=t.substring(r+2)}if(r=t.indexOf(x),-1!=r&&(n.path=t.substring(r),t=t.substring(0,r)),r=t.indexOf(E),-1!=r&&(n.userInfo=t.substring(0,r)||d,t=t.substring(r+1)),r=t.indexOf(":"),-1!=r){var c=parseInt(u.trim(t.substring(r+1)));if(isNaN(c))return new o.ArgumentException("url","Port was invalid.");n.port=c,t=t.substring(0,r)}return t=u.trim(t),t&&(n.host=t),e(a(n)),null}var d=void 0,b=function(){function t(t,e,i,u,o,s,a){var c=this;c.scheme=f(t)||null,c.userInfo=e||null,c.host=i||null,c.port=p(u),c.authority=c.getAuthority()||null,c.path=o||null,r.Type.isString(s)||(s=n.encode(s)),c.query=h(s)||null,Object.freeze(c.queryParams=c.query?n.parseToMap(c.query):{}),c.pathAndQuery=c.getPathAndQuery()||null,c.fragment=l(a)||null,c.absoluteUri=c.getAbsoluteUri(),c.baseUri=c.absoluteUri.replace(/[?#].*/,""),Object.freeze(c)}return t.prototype.equals=function(e){return this===e||this.absoluteUri==t.toString(e)},t.from=function(e,n){var i=!e||r.Type.isString(e)?t.parse(e):e;return new t(i.scheme||n&&n.scheme,i.userInfo||n&&n.userInfo,i.host||n&&n.host,isNaN(i.port)?n&&n.port:i.port,i.path||n&&n.path,i.query||n&&n.query,i.fragment||n&&n.fragment)},t.parse=function(t,e){void 0===e&&(e=!0);var r=null,n=m(t,function(t){r=t});if(e&&n)throw n;return r},t.tryParse=function(t,e){return!m(t,e)},t.copyOf=function(t){return a(t)},t.prototype.copyTo=function(t){return a(this,t)},t.prototype.updateQuery=function(e){var r=this.toMap();return r.query=e,t.from(r)},t.prototype.getAbsoluteUri=function(){return y(this)},t.prototype.getAuthority=function(){return c(this)},t.prototype.getPathAndQuery=function(){return g(this)},Object.defineProperty(t.prototype,"pathSegments",{get:function(){return this.path.match(/^[\/]|[^\/]*[\/]|[^\/]+$/g)},enumerable:!0,configurable:!0}),t.prototype.toMap=function(){return this.copyTo({})},t.prototype.toString=function(){return this.absoluteUri},t.toString=function(e){return e instanceof t?e.absoluteUri:y(e)},t.getAuthority=function(t){return c(t)},t}();e.Uri=b,function(t){t[t.scheme=0]="scheme",t[t.userInfo=1]="userInfo",t[t.host=2]="host",t[t.port=3]="port",t[t.path=4]="path",t[t.query=5]="query",t[t.fragment=6]="fragment"}(e.Fields||(e.Fields={}));var v=e.Fields;Object.freeze(v);var x="/",w="//",O=n.Separator.Query,A="#",q="",E="@";Object.defineProperty(e,"__esModule",{value:!0}),e["default"]=b});
//# sourceMappingURL=Uri.js.map
