/*!
 * @author electricessence / https://github.com/electricessence/
 * Based Upon: http://msdn.microsoft.com/en-us/library/he2s3bh7%28v=vs.110%29.aspx
 * Licensing: MIT https://github.com/electricessence/TypeScript.NET/blob/master/LICENSE.md
 */
var __extends=this&&this.__extends||function(t,e){function n(){this.constructor=t}for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o]);t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)};!function(t){if("object"==typeof module&&"object"==typeof module.exports){var e=t(require,exports);void 0!==e&&(module.exports=e)}else"function"==typeof define&&define.amd&&define(["require","exports","../Compare","./LinkedNodeList","../Exceptions/InvalidOperationException","../Exceptions/ArgumentNullException","./CollectionBase"],t)}(function(t,e){"use strict";function n(t,e){if(!t)return null;if(!e)throw new s.ArgumentNullException("list");var n=t.external;return n||(t.external=n=new f(e,t)),n}function o(t,e){if(!t)throw new s.ArgumentNullException("node");if(!e)throw new s.ArgumentNullException("list");if(t.list!=e)throw new a.InvalidOperationException("Provided node does not belong to this list.");var n=t._nodeInternal;if(!n)throw new a.InvalidOperationException("Provided node is not valid.");return n}var i=t("../Compare"),r=t("./LinkedNodeList"),a=t("../Exceptions/InvalidOperationException"),s=t("../Exceptions/ArgumentNullException"),l=t("./CollectionBase"),u=function(){function t(t,e,n){this.value=t,this.previous=e,this.next=n}return t.prototype.assertDetached=function(){if(this.next||this.previous)throw new a.InvalidOperationException("Adding a node that is already placed.")},t}(),d=function(t){function e(e,n){void 0===n&&(n=i.areEqual),t.call(this,null,n);var o=this;o._listInternal=new r.LinkedNodeList,o._importEntries(e)}return __extends(e,t),e.prototype.getCount=function(){return this._listInternal.unsafeCount},e.prototype._addInternal=function(t){return this._listInternal.addNode(new u(t)),!0},e.prototype._removeInternal=function(t,e){void 0===e&&(e=1/0);var n=this,o=n._equalityComparer,i=n._listInternal,r=0;return i.forEach(function(n){return o(t,n.value)&&i.removeNode(n)&&r++,e>r}),r},e.prototype._clearInternal=function(){return this._listInternal.clear()},e.prototype.forEach=function(e,n){return void 0===n&&(n=!1),n?t.prototype.forEach.call(this,e,n):this._listInternal.forEach(function(t,n){return e(t.value,n)})},e.prototype.getEnumerator=function(){return r.LinkedNodeList.valueEnumeratorFrom(this._listInternal)},e.prototype._findFirst=function(t){for(var e=this,n=e._equalityComparer,o=e._listInternal.first;o;){if(n(t,o.value))return o;o=o.next}return null},e.prototype._findLast=function(t){for(var e=this,n=e._equalityComparer,o=e._listInternal.last;o;){if(n(t,o.value))return o;o=o.previous}return null},e.prototype.removeOnce=function(t){return 0!==this.remove(t,1)},Object.defineProperty(e.prototype,"first",{get:function(){return n(this._listInternal.first,this)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"last",{get:function(){return n(this._listInternal.last,this)},enumerable:!0,configurable:!0}),e.prototype.getValueAt=function(t){var e=this._listInternal.getNodeAt(t);return e?void 0:e&&e.value||void 0},e.prototype.getNodeAt=function(t){return n(this._listInternal.getNodeAt(t),this)},e.prototype.find=function(t){return n(this._findFirst(t),this)},e.prototype.findLast=function(t){return n(this._findLast(t),this)},e.prototype.addFirst=function(t){this._listInternal.addNodeBefore(new u(t)),this._signalModification(!0)},e.prototype.addLast=function(t){this.add(t)},e.prototype.removeFirst=function(){var t=this,e=t._listInternal.first;e&&t._listInternal.removeNode(e)&&t._signalModification(!0)},e.prototype.removeLast=function(){var t=this,e=t._listInternal.last;e&&t._listInternal.removeNode(e)&&t._signalModification(!0)},e.prototype.removeNode=function(t){var e=this;return e._listInternal.removeNode(o(t,e))?(e._signalModification(!0),!0):!1},e.prototype.addBefore=function(t,e){var n=this;n._listInternal.addNodeBefore(new u(e),o(t,n)),n._signalModification(!0)},e.prototype.addAfter=function(t,e){var n=this;n._listInternal.addNodeAfter(new u(e),o(t,n)),n._signalModification(!0)},e.prototype.addNodeBefore=function(t,e){var n=this;n._listInternal.addNodeBefore(o(e,n),o(t,n)),n._signalModification(!0)},e.prototype.addNodeAfter=function(t,e){var n=this;this._listInternal.addNodeAfter(o(e,n),o(t,n)),n._signalModification(!0)},e}(l.CollectionBase);e.LinkedList=d;var f=function(){function t(t,e){this._list=t,this._nodeInternal=e}return Object.defineProperty(t.prototype,"list",{get:function(){return this._list},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"previous",{get:function(){return n(this._nodeInternal.previous,this._list)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"next",{get:function(){return n(this._nodeInternal.next,this._list)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"value",{get:function(){return this._nodeInternal.value},set:function(t){this._nodeInternal.value=t},enumerable:!0,configurable:!0}),t.prototype.addBefore=function(t){this._list.addBefore(this,t)},t.prototype.addAfter=function(t){this._list.addAfter(this,t)},t.prototype.addNodeBefore=function(t){this._list.addNodeBefore(this,t)},t.prototype.addNodeAfter=function(t){this._list.addNodeAfter(this,t)},t.prototype.remove=function(){this._list.removeNode(this)},t}();Object.defineProperty(e,"__esModule",{value:!0}),e["default"]=d});
//# sourceMappingURL=LinkedList.js.map
