/*!
 * @author electricessence / https://github.com/electricessence/
 * Based Upon: http://referencesource.microsoft.com/#System/CompMod/system/collections/generic/queue.cs
 * Licensing: MIT https://github.com/electricessence/TypeScript.NET/blob/master/LICENSE.md
 */
var __extends=this&&this.__extends||function(e,t){function i(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(i.prototype=t.prototype,new i)};!function(e){if("object"==typeof module&&"object"==typeof module.exports){var t=e(require,exports);void 0!==t&&(module.exports=t)}else"function"==typeof define&&define.amd&&define(["require","exports","../Compare","./Array/Utility","../Types","../Integer","./Enumeration/EnumeratorBase","../Exceptions/NotImplementedException","../Exceptions/InvalidOperationException","../Exceptions/ArgumentOutOfRangeException","./CollectionBase"],e)}(function(e,t){"use strict";function i(e,t){if(0>e)throw new _.ArgumentOutOfRangeException(t,e,"Must be greater than zero")}function r(e,t){s.Integer.assert(e,t),i(e,t)}var n=e("../Compare"),a=e("./Array/Utility"),o=e("../Types"),s=e("../Integer"),p=e("./Enumeration/EnumeratorBase"),c=e("../Exceptions/NotImplementedException"),u=e("../Exceptions/InvalidOperationException"),_=e("../Exceptions/ArgumentOutOfRangeException"),l=e("./CollectionBase"),y=4,f=32,d=100,h=y,v=[],m=function(e){function t(t,i){void 0===i&&(i=n.areEqual),e.call(this,null,i);var s=this;if(s._head=0,s._tail=0,s._size=0,t)if(o.Type.isNumber(t)){var p=t;r(p,"capacity"),s._array=p?a.initialize(p):v}else{var c=t;s._array=a.initialize(o.Type.isArrayLike(c)?c.length:h),s._importEntries(c)}else s._array=v;s._capacity=s._array.length}return __extends(t,e),t.prototype.getCount=function(){return this._size},t.prototype._addInternal=function(e){var t=this,i=t._array,r=t._size,n=t._capacity;if(r==n){var a=n*d;n+y>a&&(a=n+y),t.setCapacity(a),i=t._array,n=t._capacity}var o=t._tail;return i[o]=e,t._tail=(o+1)%n,t._size=r+1,!0},t.prototype._removeInternal=function(e,t){throw new c.NotImplementedException("ICollection<T>.remove is not implemented in Queue<T> since it would require destroying the underlying array to remove the item.")},t.prototype._clearInternal=function(){var e=this,t=e._array,i=e._head,r=e._tail,n=e._size;return r>i?a.clear(t,i,r):(a.clear(t,i,t.length-i),a.clear(t,0,r)),e._head=0,e._tail=0,e._size=0,e.trimExcess(),n},t.prototype._onDispose=function(){e.prototype._onDispose.call(this);var t=this;t._array!=v&&(t._array.length=t._capacity=0,t._array=v)},t.prototype.dump=function(e){void 0===e&&(e=1/0);var t=this,i=[];if(isFinite(e)){if(s.Integer.assertZeroOrGreater(e),0!==e)for(;e--&&t._size;)i.push(t._dequeueInternal())}else for(;t._size;)i.push(t._dequeueInternal());return t.trimExcess(),t._signalModification(),i},t.prototype.forEach=function(t){return e.prototype.forEach.call(this,t,!0)},t.prototype.setCapacity=function(e){r(e,"capacity");var t=this,i=t._array,n=t._capacity;if(e!=n){var o=t._head,s=t._tail,p=t._size;if(i!=v&&e>n&&s>o)return i.length=t._capacity=e,void t._version++;var c=a.initialize(e);p>0&&(s>o?a.copyTo(i,c,o,0,p):(a.copyTo(i,c,o,0,n-o),a.copyTo(i,c,0,n-o,s))),t._array=c,t._capacity=e,t._head=0,t._tail=p==e?0:p,t._signalModification(!0)}},t.prototype.enqueue=function(e){this.add(e)},t.prototype._dequeueInternal=function(e){void 0===e&&(e=!1);var t=this;{if(0!=t._size){var i=t._array,r=t._head,n=t._array[r];return i[r]=null,t._head=(r+1)%t._capacity,t._size--,t._incrementModified(),n}if(e)throw new u.InvalidOperationException("Cannot dequeue an empty queue.")}},t.prototype.dequeue=function(e){void 0===e&&(e=!1);var t=this;t.assertModifiable();var i=!!t._size,r=this._dequeueInternal(e);return i&&t._size<t._capacity/2&&t.trimExcess(f),t._signalModification(),r},t.prototype.tryDequeue=function(e){if(!this._size)return!1;var t=this.dequeue();return e&&e(t),!0},t.prototype._getElement=function(e){r(e,"index");var t=this;return t._array[(t._head+e)%t._capacity]},t.prototype.peek=function(){if(0==this._size)throw new u.InvalidOperationException("Cannot call peek on an empty queue.");return this._array[this._head]},t.prototype.trimExcess=function(e){var t=this,i=t._size;i<Math.floor(.9*t._capacity)&&(isNaN(e)||i>e)&&t.setCapacity(i)},t.prototype.getEnumerator=function(){var e,t,i=this;return new p.EnumeratorBase(function(){t=i._version,e=0},function(r){return i.assertVersion(t),e==i._size?r.yieldBreak():r.yieldReturn(i._getElement(e++))})},t}(l.CollectionBase);t.Queue=m,Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=m});
//# sourceMappingURL=Queue.js.map
